def atom_typing(vectors, atomic_nums, coordinates):
      import math
      AT_radii = [0.38, 1.11, 0.86, 0.53, 1.01, 0.88, 0.86, 0.89, 0.82, 1.30, 1.15, 1.28, 1.53, 1.38, 1.28, 1.20, 1.17, 1.75, 1.44, 1.17,
                  1.62, 1.65, 1.51, 1.53, 1.53, 1.43, 1.31, 1.33, 1.31, 1.41, 1.40, 1.35, 1.39, 1.40, 1.39, 2.09, 1.65, 1.30, 1.84, 1.73,
                  1.66, 1.57, 1.53, 1.58, 1.63, 1.68, 1.56, 1.56, 1.53, 1.64, 1.64, 1.65, 1.58, 2.16, 1.85, 1.52, 1.91, 1.98, 1.75, 1.92,
                  1.98, 1.89, 1.83, 1.79, 1.82, 1.79, 1.63, 1.80, 1.84, 1.80, 1.86, 1.73, 1.61, 1.33, 1.29, 1.55, 1.50, 1.66, 1.68, 1.88,
                  1.73, 1.72, 1.72, 1.86, 1.88, 2.58, 2.18, 2.08, 2.06, 1.97, 1.79, 1.76, 1.73, 1.71]
      atom_num = []; coor_000 = []; atom_types = []
      neighbor_list_atom_num_temp = []; neighbor_list_atomic_num_temp = []
      neighbor_list_atom_num = []; neighbor_list_atomic_num = []; neighbor_list_len = []
      coor_010 = []; coor_001 = []; coor_011 = []; coor_020 = []; coor_002 = []; coor_022 = []; coor_012 = []; coor_021 = []
      coor_100 = []; coor_110 = []; coor_101 = []; coor_111 = []; coor_120 = []; coor_102 = []; coor_122 = []; coor_112 = []; coor_121 = []
      coor_200 = []; coor_210 = []; coor_201 = []; coor_211 = []; coor_220 = []; coor_202 = []; coor_222 = []; coor_212 = []; coor_221 = []
      num_atoms = len(atomic_nums)
      a_vector = vectors[0]; b_vector = vectors[1]; c_vector = vectors[2]
      coor_collection = [coor_000, coor_010, coor_001, coor_011, coor_020, coor_002, coor_022, coor_012, coor_021,
                         coor_100, coor_110, coor_101, coor_111, coor_120, coor_102, coor_122, coor_112, coor_121,
                         coor_200, coor_210, coor_201, coor_211, coor_220, coor_202, coor_222, coor_212, coor_221]
      for i in range(0, num_atoms):
            atom_num.append(i + 1)
            neighbor_list_atom_num_temp.append([])
            neighbor_list_atomic_num_temp.append([])
            coor_000.append(coordinates[i])
            coor_010.append([coor_000[i][0] + b_vector[0], coor_000[i][1] + b_vector[1], coor_000[i][2] + b_vector[2]])
            coor_001.append([coor_000[i][0] + c_vector[0], coor_000[i][1] + c_vector[1], coor_000[i][2] + c_vector[2]])
            coor_011.append([coor_000[i][0] + b_vector[0] + c_vector[0], coor_000[i][1] + b_vector[1] + c_vector[1], coor_000[i][2] + b_vector[2] + c_vector[2]])
            coor_020.append([coor_000[i][0] - b_vector[0], coor_000[i][1] - b_vector[1], coor_000[i][2] - b_vector[2]])
            coor_002.append([coor_000[i][0] - c_vector[0], coor_000[i][1] - c_vector[1], coor_000[i][2] - c_vector[2]])
            coor_022.append([coor_000[i][0] - b_vector[0] - c_vector[0], coor_000[i][1] - b_vector[1] - c_vector[1], coor_000[i][2] - b_vector[2] - c_vector[2]])
            coor_012.append([coor_000[i][0] + b_vector[0] - c_vector[0], coor_000[i][1] + b_vector[1] - c_vector[1], coor_000[i][2] + b_vector[2] - c_vector[2]])
            coor_021.append([coor_000[i][0] - b_vector[0] + c_vector[0], coor_000[i][1] - b_vector[1] + c_vector[1], coor_000[i][2] - b_vector[2] + c_vector[2]])
            coor_100.append([coor_000[i][0] + a_vector[0], coor_000[i][1] + a_vector[1], coor_000[i][2] + a_vector[2]])
            coor_110.append([coor_000[i][0] + a_vector[0] + b_vector[0], coor_000[i][1] + a_vector[1] + b_vector[1], coor_000[i][2] + a_vector[2] + b_vector[2]])
            coor_101.append([coor_000[i][0] + a_vector[0] + c_vector[0], coor_000[i][1] + a_vector[1] + c_vector[1], coor_000[i][2] + a_vector[2] + c_vector[2]])
            coor_111.append([coor_000[i][0] + a_vector[0] + b_vector[0] + c_vector[0], coor_000[i][1] + a_vector[1] + b_vector[1] + c_vector[1], coor_000[i][2] + a_vector[2] + b_vector[2] + c_vector[2]])
            coor_120.append([coor_000[i][0] + a_vector[0] - b_vector[0], coor_000[i][1] + a_vector[1] - b_vector[1], coor_000[i][2] + a_vector[2] - b_vector[2]])
            coor_102.append([coor_000[i][0] + a_vector[0] - c_vector[0], coor_000[i][1] + a_vector[1] - c_vector[1], coor_000[i][2] + a_vector[2] - c_vector[2]])
            coor_122.append([coor_000[i][0] + a_vector[0] - b_vector[0] - c_vector[0], coor_000[i][1] + a_vector[1] - b_vector[1] - c_vector[1], coor_000[i][2] + a_vector[2] - b_vector[2] - c_vector[2]])
            coor_112.append([coor_000[i][0] + a_vector[0] + b_vector[0] - c_vector[0], coor_000[i][1] + a_vector[1] + b_vector[1] - c_vector[1], coor_000[i][2] + a_vector[2] + b_vector[2] - c_vector[2]])
            coor_121.append([coor_000[i][0] + a_vector[0] - b_vector[0] + c_vector[0], coor_000[i][1] + a_vector[1] - b_vector[1] + c_vector[1], coor_000[i][2] + a_vector[2] - b_vector[2] + c_vector[2]])
            coor_200.append([coor_000[i][0] - a_vector[0], coor_000[i][1] - a_vector[1], coor_000[i][2] - a_vector[2]])
            coor_210.append([coor_000[i][0] - a_vector[0] + b_vector[0], coor_000[i][1] - a_vector[1] + b_vector[1], coor_000[i][2] - a_vector[2] + b_vector[2]])
            coor_201.append([coor_000[i][0] - a_vector[0] + c_vector[0], coor_000[i][1] - a_vector[1] + c_vector[1], coor_000[i][2] - a_vector[2] + c_vector[2]])
            coor_211.append([coor_000[i][0] - a_vector[0] + b_vector[0] + c_vector[0], coor_000[i][1] - a_vector[1] + b_vector[1] + c_vector[1], coor_000[i][2] - a_vector[2] + b_vector[2] + c_vector[2]])
            coor_220.append([coor_000[i][0] - a_vector[0] - b_vector[0], coor_000[i][1] - a_vector[1] - b_vector[1], coor_000[i][2] - a_vector[2] - b_vector[2]])
            coor_202.append([coor_000[i][0] - a_vector[0] - c_vector[0], coor_000[i][1] - a_vector[1] - c_vector[1], coor_000[i][2] - a_vector[2] - c_vector[2]])
            coor_222.append([coor_000[i][0] - a_vector[0] - b_vector[0] - c_vector[0], coor_000[i][1] - a_vector[1] - b_vector[1] - c_vector[1], coor_000[i][2] - a_vector[2] - b_vector[2] - c_vector[2]])
            coor_212.append([coor_000[i][0] - a_vector[0] + b_vector[0] - c_vector[0], coor_000[i][1] - a_vector[1] + b_vector[1] - c_vector[1], coor_000[i][2] - a_vector[2] + b_vector[2] - c_vector[2]])
            coor_221.append([coor_000[i][0] - a_vector[0] - b_vector[0] + c_vector[0], coor_000[i][1] - a_vector[1] - b_vector[1] + c_vector[1], coor_000[i][2] - a_vector[2] - b_vector[2] + c_vector[2]])
      for j in range(0, num_atoms):
            for k in [m for m in range(num_atoms) if m != j]:
                  distances = []
                  for l in range(0, len(coor_collection)):
                        distances.append(math.sqrt(((coor_collection[l][k][0]-coor_collection[0][j][0])**2) + ((coor_collection[l][k][1]-coor_collection[0][j][1])**2) + ((coor_collection[l][k][2]-coor_collection[0][j][2])**2)))
                  bond_distance = AT_radii[atomic_nums[j] - 1] + AT_radii[atomic_nums[k] - 1]
                  for distance in distances:
                        if distance <= bond_distance:
                            neighbor_list_atom_num_temp[j].append(atom_num[k])
                            neighbor_list_atomic_num_temp[j].append(atomic_nums[k])
            print(neighbor_list_atom_num_temp[j])
      for n in range(0, len(neighbor_list_atom_num_temp)):
            neighbor_list_atom_num.append([x for _,x in sorted(zip(neighbor_list_atomic_num_temp[n], neighbor_list_atom_num_temp[n]))])
            neighbor_list_atomic_num_temp[n].sort()
            neighbor_list_atomic_num.append(neighbor_list_atomic_num_temp[n])
            neighbor_list_len.append(len(neighbor_list_atomic_num_temp[n]))
      for p in range(0, num_atoms):
            SN_list = []
            str_SN_list = []
            str_SN_list_join = []
            str_SNG = []
            for q in range(0, len(neighbor_list_atom_num[p])):
                  neighbor_index = neighbor_list_atom_num[p][q] - 1
                  neighbors_neighbor = neighbor_list_atomic_num[neighbor_index]
                  neighbors_neighbor_pure = []
                  self_exclusion_index = neighbor_list_atom_num[neighbor_index].index(atom_num[p])
                  neighbors_neighbor_num = len(neighbors_neighbor) - 1
                  self = neighbors_neighbor[self_exclusion_index]
                  for item in neighbors_neighbor:
                        neighbors_neighbor_pure.append(item)
                  neighbors_neighbor_pure.remove(self)
                  if neighbors_neighbor_num == 0:
                        SN_list.append([0])
                        str_SN_list.append([])
                  elif neighbors_neighbor_num > 0:
                        SN_list.append(neighbors_neighbor_pure)
                        str_SN_list.append([])
            str_neighbor_list_atomic_num = [str(o) for o in neighbor_list_atomic_num[p]]
            for kk in range(0, len(str_neighbor_list_atomic_num)):
                  if len(str_neighbor_list_atomic_num[kk]) == 1:
                        str_neighbor_list_atomic_num[kk] = '0' + str_neighbor_list_atomic_num[kk]
            for r in range(0, len(SN_list)):
                  for s in range(0, len(SN_list[r])):
                        str_SN_list[r].append(str(SN_list[r][s]))
                  str_SN_list_join.append('(' + ','.join(str_SN_list[r]) + ')')
                  str_SNG.append(str_neighbor_list_atomic_num[r] + '-(' + ','.join(str_SN_list[r]) + ')')
            str_SNG.sort()
            for ll in range(0, len(str_SNG)):
                  if str_SNG[ll].startswith('0'):
                        str_SNG[ll] = str_SNG[ll][1:]
            atom_type = str(atomic_nums[p]) + '[' + ','.join(str_SNG) + ']'
            atom_types.append(atom_type)
      return atom_types
